//------------------------------------------------------------
//    agari.h
//------------------------------------------------------------
#include "agari.h"

bool agari_hantei(Tehai* te1)
{
	bool b1;
	
	if(kokusi(te1)) return(true);
	if(titoi(te1)) return(true);
	if(hutsuute(te1)) return(true);
	return(false);
}

bool kokusi(Tehai* te1)
{
	int i1;
	bool gee1 = true;
	for(i1 = 0; i1 < 9; i1++){
		gee1 &= (te1->manz[i1] == 0);
		gee1 &= (te1->pinz[i1] == 0);
		gee1 &= (te1->souz[i1] == 0);
	}
	for(i1 = 0; i1 < 7; i1++){
		gee1 &= (te1->jihai[i1] > 0);
	}
	return(gee1);
}

bool titoi(Tehai* te1)
{
	int i1;
	bool gee1 = true;
	for(i1 = 0; i1 < 9; i1++){
		gee1 &= ((te1->manz[i1] == 2)||(te1->manz[i1] == 0));
		gee1 &= ((te1->pinz[i1] == 2)||(te1->pinz[i1] == 0));
		gee1 &= ((te1->souz[i1] == 2)||(te1->souz[i1] == 0));
	}
	for(i1 = 0; i1 < 7; i1++){
		gee1 &= ((te1->jihai[i1] == 2)||(te1->jihai[i1] == 0));
	}
	return(gee1);
}

bool hutsuute(Tehai* te1)
{
	int i1;
	bool b1;
	Tehai te2;
	
	
	for(i1 = 0; i1 < 7; i1++){
		te2 = (*te1);
		if(te2.jihai[i1]>=2){
			te2.jihai[i1] -= 2;
			b1 = find_agari(&te2);
			if(b1) return(true);
		}
	}
	for(i1 = 0; i1 < 9; i1++){
		te2 = (*te1);
		if(te2.manz[i1]>=2){
			te2.manz[i1] -= 2;
			b1 = find_agari(&te2);
			if(b1) return(true);
		}
	}
	for(i1 = 0; i1 < 9; i1++){
		te2 = (*te1);
		if(te2.pinz[i1]>=2){
			te2.pinz[i1] -= 2;
			b1 = find_agari(&te2);
			if(b1) return(true);
		}
	}
	for(i1 = 0; i1 < 9; i1++){
		te2 = (*te1);
		if(te2.souz[i1]>=2){
			te2.souz[i1] -= 2;
			b1 = find_agari(&te2);
			if(b1) return(true);
		}
	}
	return(false);
}

bool find_agari(Tehai* te1)
{
	bool b1, b2;
	Tehai te3;
	if(sum_hai(te1)==0) return(true);
	te3 = (*te1);
	
	b2 = false;
	b1 = pick_koutsu(&te3);
	if(b1) b2 = find_agari(&te3);
	if(b2) return(true);
	
	te3 = (*te1);
	b1 = pick_shuntsu(&te3);
	if(b1) b2 = find_agari(&te3);
	if(b2) return(true);
	
	return(false);
}

int sum_hai(Tehai* te1)
{
	int i1, count = 0;
	for(i1 = 0; i1 < 9; i1++){
		count += te1->manz[i1] + te1->pinz[i1] + te1->souz[i1];
	}
	for(i1 = 0; i1 < 7; i1++){
		count += te1->jihai[i1];
	}
	return(count);
}

bool pick_koutsu(Tehai* te1)
{
	int i1;
	for(i1 = 0; i1 < 9; i1++){
		if(te1->manz[i1]==3){
			te1->manz[i1] -= 3;
			return true;
		}
	}
	for(i1 = 0; i1 < 9; i1++){
		if(te1->pinz[i1]==3){
			te1->pinz[i1] -= 3;
			return true;
		}
	}
	for(i1 = 0; i1 < 9; i1++){
		if(te1->souz[i1]==3){
			te1->souz[i1] -= 3;
			return true;
		}
	}
	for(i1 = 0; i1 < 7; i1++){
		if(te1->jihai[i1]==3){
			te1->jihai[i1] -= 3;
			return true;
		}
	}
	return(false);
}

bool pick_shuntsu(Tehai* te1)
{
	int i1;
	for(i1 = 0; i1 < 7; i1++){
		if((te1->manz[i1]>0)&&(te1->manz[i1+1]>0)&&(te1->manz[i1+2]>0)){
			te1->manz[i1]--;
			te1->manz[i1+1]--;
			te1->manz[i1+2]--;
			return true;
		}
	}
	for(i1 = 0; i1 < 7; i1++){
		if((te1->pinz[i1]>0)&&(te1->pinz[i1+1]>0)&&(te1->pinz[i1+2]>0)){
			te1->pinz[i1]--;
			te1->pinz[i1+1]--;
			te1->pinz[i1+2]--;
			return true;
		}
	}
	for(i1 = 0; i1 < 7; i1++){
		if((te1->souz[i1]>0)&&(te1->souz[i1+1]>0)&&(te1->souz[i1+2]>0)){
			te1->souz[i1]--;
			te1->souz[i1+1]--;
			te1->souz[i1+2]--;
			return true;
		}
	}
	return(false);
}
