//-----------------------------------------------------------
//    seki
//-----------------------------------------------------------
#include <algorithm>
#include "seki.h"
#include "pai.h"
#include "agari.h"
//------------------------------------------------------------
//    constructor
//------------------------------------------------------------
Seki::Seki()
{
}

//------------------------------------------------------------
//    destructor
//------------------------------------------------------------
Seki::~Seki()
{
}

void Seki::Da(int dahai)
{
	if((dahai>=0)&&(dahai<=12)){
		kawa[junme] = te[dahai];
		te[dahai] = tumo_hai;
	}else if(dahai==13){
		kawa[junme] = tumo_hai;
	}
	Rihai();
	junme++;
}

void Seki::Rihai()
{
	std::sort(te, te + 13);
}


void Seki::set_haipai(int *pi)
{
	int i1;
	for(i1 = 0; i1 < 13; i1++){
		te[i1] = pi[i1];
	}
	for(i1 = 0; i1 < 22; i1++){
		kawa[i1] = -1;
	}
	Rihai();
	junme = 0;
}

void Seki::get(int *pi)
{
	int i1;
	for(i1 = 0; i1 < 13; i1++){
		pi[i1] = te[i1];
	}
}

void Seki::set_tumo_hai(int pai0)
{
	tumo_hai = pai0;
}

int Seki::get_tumo_hai()
{
	return(tumo_hai);
}

int Seki::get_reach()
{
	return(reach);
}

int Seki::get_junme()
{
	return(junme);
}

void Seki::set_reach(int r1)
{
	reach = r1;
}

void Seki::get_kawa(int *p1)
{
	int i1;
	for(i1 = 0; i1 < 22; i1++){
		p1[i1] = kawa[i1];
	}
}

int Seki::get_kawa_hai(int p2)
{
	return(kawa[p2]);
}

bool Seki::agari()
{
	Tehai teh1 = {
		{0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0}};
	int i1, h1, p[14];
	bool b1;
	
	if(tumo_hai<0) return(false);
	for(i1 = 0; i1 < 13; i1++){
		p[i1] = te[i1];
	}
	p[13] = tumo_hai;
	
	for(i1 = 0; i1 < 14; i1++){
		h1 = p[i1];
		if((h1 >= 0) && (h1 < 9)){
			teh1.manz[h1] += 1;
		}else if((h1 >= 9) && (h1 < 18)){
			h1 -= 9;
			teh1.pinz[h1] += 1;
		}else if((h1 >= 18) && (h1 < 27)){
			h1 -= 18;
			teh1.souz[h1] += 1;
		}else{
			h1 -= 27;
			teh1.jihai[h1] += 1;
		}
	}
	
	b1 = agari_hantei(&teh1);
	return(b1);
}
