//
#include "main.h"
#include "mjapp.h"
#include "v/mjframe.h"
#include "c/mjcontroller.h"
#include <wx/wx.h>
#include <wx/image.h>

IMPLEMENT_APP(mjApp)

bool mjApp::OnInit()
{
	wxInitAllImageHandlers();
	mjController *controller_1;
	mjFrame *frame_1 = new mjFrame(NULL, wxID_ANY,
			wxEmptyString, wxPoint(100, 100),
			wxDefaultSize,
			wxDEFAULT_FRAME_STYLE);
	tMajan *tmajan_1 = new tMajan();
	controller_1 = new mjController(this, frame_1, tmajan_1);
	
	frame_1->set_tMajan(tmajan_1);
	frame_1->set_pai_images();
	frame_1->SetEventHandler(controller_1);
	frame_1->panel_1->SetEventHandler(controller_1);
	
	controller_1->Connect(wxEVT_CLOSE_WINDOW,
			wxCloseEventHandler(mjController::OnClose),
			NULL);
	controller_1->Connect(restart_button_id, wxEVT_COMMAND_BUTTON_CLICKED,
			wxCommandEventHandler(mjController::OnRestartButton),
			NULL);
	
	SetTopWindow(frame_1);
	frame_1->Show();
	
	controller_1->mj_1play();
	return true;
}
