//------------------------------------------------------------
//    mjframe
//------------------------------------------------------------
#include "../m/tmajan.h"
#include <wx/wx.h>
#include <wx/image.h>
#include <wx/glcanvas.h>
#ifndef __MJFRAME_H__
#define __MJFRAME_H__

class mjFrame: public wxFrame {
public:
	mjFrame(wxWindow* parent,
			int id, const wxString& title,
			const wxPoint& pos=wxDefaultPosition,
			const wxSize& size=wxDefaultSize,
			long style=wxDEFAULT_FRAME_STYLE);
	void update_tehai_image();
	void update_tumo_image();
	void update_sutehai_image();
	void draw_dora_image();
	void draw_images();
	void set_tMajan(tMajan *tmj1);
	void set_pai_images();
	void images_init();
	wxPanel* panel_1;
private:
	void set_properties();
	void do_layout();
	tMajan *majan_1;
protected:
	wxButton* button_1;
	wxButton* button_2;
	wxButton* button_3;
	wxMenuBar* frame_1_menubar;
	wxBitmap main_img;
	wxBitmap pai_images[35];
};
#endif

