//-----------------------------------------------------------
//    mjcontroller.cpp
//-----------------------------------------------------------
#include "mjcontroller.h"
#include "../main.h"
//-----------------------------------------------------------
//    constructor
//-----------------------------------------------------------
mjController::mjController(mjApp *a1, mjFrame *f1, tMajan *tmj1)
{
	frame_1 = f1;
	majan_1 = tmj1;
	app_1 = a1;
}

//------------------------------------------------------------
//    destructor
//------------------------------------------------------------
mjController::~mjController()
{
	
}

//-----------------------------------------------------------
//    mjControl::mj_1play
//-----------------------------------------------------------
void mjController::mj_1play()
{
	int i1, n1, s1, pais[14], t1;
	bool b1;
	
	majan_1->play_init();
	frame_1->images_init();
	this->Connect(wxEVT_LEFT_UP,
		wxMouseEventHandler(mjController::OnClickPanel),
		NULL);
	this->Connect(panel_id, wxEVT_PAINT,
		wxPaintEventHandler(mjController::OnPaintPanel),
		NULL);
	frame_1->panel_1->Refresh();
	while(majan_1->playing){
		if(majan_1->tumo_flg == false){
			n1 = majan_1->seki_1->get_junme() + 14;
			if(n1==30){
				majan_1->seki_1->set_tumo_hai(-1);
				majan_1->playing = false;
				majan_1->tumo_flg = false;
			}else{
				t1 = majan_1->get_yama_hai(n1);
				majan_1->seki_1->set_tumo_hai(t1);
				majan_1->tumo_flg = true;
			}
			frame_1->panel_1->Refresh();
			b1 = majan_1->seki_1->agari();
			if(b1){
				wxMessageDialog dialog1(frame_1, wxT("agari"), wxT("agari"), wxOK );
				dialog1.ShowModal();
				majan_1->playing = false;
				majan_1->tumo_flg = false;
				majan_1->tumo_flg = false;
			}
		}else{
			wxMilliSleep(1);
			app_1->Yield();
		}
	}
}

//------------------------------------------------------------
//    mjController::ConnectEvents()
//------------------------------------------------------------
void mjController::ConnectEvents()
{
	
}

//------------------------------------------------------------
//    event
//------------------------------------------------------------
//-----------------------------------------------------------
//    mjController::OnPaint
//-----------------------------------------------------------
void mjController::OnPaintPanel(wxPaintEvent& event)
{
	frame_1->draw_images();
}

//-----------------------------------------------------------
//    mjController::OnClick
//-----------------------------------------------------------
void mjController::OnClickPanel(wxMouseEvent& event)
{
	int i1, p1, p2, hai;
	if(majan_1->tumo_flg){
		hai = -1;
		if(((event.m_x - tehai_pos[0])>=0)
		 &&((event.m_x - tehai_pos[0])<=tehai_size[0])
		 &&((event.m_y - tehai_pos[1])>=0)
		 &&((event.m_y - tehai_pos[1])<=tehai_size[1])){
			p1 = event.m_x - tehai_pos[0];
			for(i1 = 0; i1 < 13; i1++){
				if(p1 < pai_size[0]){
					hai = i1;
					i1 = 13;
				}
				p1 -= pai_size[0];
			}
		}
		
		if(((event.m_x - tumo_pos[0])>=0)
		 &&((event.m_x - tumo_pos[0])<=tumo_size[0])
		 &&((event.m_y - tumo_pos[1])>=0)
		 &&((event.m_y - tumo_pos[1])<=tumo_size[1])){
			hai = 13;
		}
		
		if(hai!=-1){
			majan_1->seki_1->Da(hai);
			majan_1->tumo_flg = false;
		}
	}
}

//-----------------------------------------------------------
//    mjController::OnRestartButton
//-----------------------------------------------------------
void mjController::OnRestartButton(wxCommandEvent& event)
{
	if(majan_1->playing==true){
		majan_1->play_init();
		frame_1->images_init();
		frame_1->panel_1->Refresh();
	}else{
		mj_1play();
	}
}

//-----------------------------------------------------------
//    mjController::OnAgariButton
//-----------------------------------------------------------
void mjController::OnAgariButton(wxCommandEvent& event)
{
	Disconnect(restart_button_id, wxEVT_COMMAND_BUTTON_CLICKED,
			wxCommandEventHandler(mjController::OnRestartButton),
			NULL);
}

//-----------------------------------------------------------
//    mjController::OnClose
//-----------------------------------------------------------
void mjController::OnClose(wxCloseEvent& event)
{
	majan_1->playing = false;
	frame_1->Destroy();
}
